@echo off
@setlocal enabledelayedexpansion
@setlocal

@REM ----------------------------------------------------------------------------------------------
@REM create_report_csv
@REM
@REM explanation:
@REM    1.analysis_report reportcsv`ŏo
@REM
@REM argument: 
@REM    %1: analysis_report path
@REM
@REM return: 
@REM    0: I
@REM    1: Error
@REM
@REM output: 
@REM    csv file
@REM ----------------------------------------------------------------------------------------------

if [%1]==[] goto :csv_empty
set "analysis_report=%~1"
goto :main

:csv_empty
echo ===[Error: Please input the arguments analysis report temp in create_report_csv.bat] 1>&2
@exit /B 1

:main
if not exist "%analysis_report%" (
    echo ===[Error: Please specify the arguments analysis report temp in create_report_csv.bat] 1>&2
    @exit /B 1
)

REM  Output header @review
echo [Project Path],[CSV Test File],[Log File Path],[Content],[Test Case], [Warning Message], [File Name], [Line No], [Column No] 

REM  analysis_reportCSVt@C𐶐
for /f "usebackq tokens=1,2,3,4,5,6,7,8,9,10 delims=," %%a in ("%analysis_report%") do (
    REM analysis result type=12,11,10Fanalysis result type,cmw project file neme, project full path,output dir,output dir full path, .sanitizerlog file path
    REM analysis result type=0F a:analysis result type, b:project full path c:.sanitizerlog file path, d:keyword, e:error message, f:handle function, g:file name, h:line number, i:column number
    REM echo ===[%%a,%%b,%%c,%%d,%%e,%%f,%%g,%%h,%%i,%%j] 1>&2

    REM cmwvWFNgJn̏ꍇ
    if "%%a"=="project_block_start" (
        set project_block_flg=1
        set csv_file_block_flg=2
        set row_block_flg=2
        set row_content=
        set out_put_html=
        set row_html_part2=
        set csv_files_name=
        set log_file_path_content=
        set csv_file_count=0
        set row_count=0
        REM echo ===[project block start] 1>&2
    )

    REM cmwvWFNgȈꍇ
    if "%%a"=="project_block_end" (
        set project_block_flg=0
        REM echo ===[project block end] 1>&2
    )

    REM subN(result_type:12,11,10,0)Jn̏ꍇ
    if "%%a"=="row_block_start" (
        set row_block_flg=1
        REM echo ===[row_block_start] 1>&2
    )

    REM subN(result_type:12,11,10,0)Ȉꍇ
    if "%%a"=="row_block_end" (
        set row_block_flg=0
        REM echo ===[row_block_end] 1>&2
    )

    REM CSV filef[^Jn̏ꍇ
    if "%%a"=="csv_file_block_start" (
        set csv_file_block_flg=1
        REM echo ===[csv_file_block_start] 1>&2
    )

    REM CSV filef[^Ȉꍇ
    if "%%a"=="csv_file_block_end" (
        set csv_file_block_flg=0
        REM echo ===[csv_file_block_end] 1>&2
    )

    REM ϐZbg
    if %%a equ 0 (
        REM analysis result type Warnings̏ꍇ
        set error_message=%%~f
        set handle_function=%%~g
        set test_count=%%~d
        set file_name=%%~h
        set line=%%~i
        set column=%%~j
    )

    if %%a equ 5 (
        REM test csv=5̏ꍇ
        set csv_file_name=%%~f
        set csv_file_path=%%~g
    )

    if %%a leq 12 (
        REM analysis result type=12ȉ̏ꍇ
        if %%a geq 10 (
            REM analysis result type=10ȏ̏ꍇ
            set result_type=%%a
            set cmw_project_file_name=%%~b
            set cmw_project_file_path=%%~c
            set output_dir=%%~d
            set output_dir_path=%%~e
            set sanitizerlog_file_name=%%~f
            set sanitizerlog_file_path=%%~g
            set warning_count_messge=%%h
            set warning_row_count=0
        )        
    )


    REM eprojectSummary message𐶐
    if %%a equ 12 (
        REM analysis result type Error ̏ꍇ @review
        set "log_meg=JobW}X^[IĂȂ\܂"
        set "leg_meg_class=alert-danger"
    ) else if %%a equ 11 (
        REM analysis result type Warning ̏ꍇ
        set "log_meg=oꂽWarning!warning_count_messge!܂"
        set "leg_meg_class=alert-warning"
    ) else if %%a equ 10 (
        REM analysis result type Success ̏ꍇ @review
        set "log_meg=oꂽWarning͂܂"
        set "leg_meg_class=alert-success"
    ) else if %%a equ 5 (
        REM test csv files̏ꍇAskip
    ) else if %%a equ 0 (
        REM analysis result type warnings̏ꍇAskip
    ) else if "%%a"=="project_block_start" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="project_block_end" (
        REM end s̏ꍇAskip
    ) else if "%%a"=="row_block_start" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="row_block_end" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="csv_file_block_start" (
        REM start s̏ꍇAskip
    ) else if "%%a"=="csv_file_block_end" (
        REM end s̏ꍇAskip
    ) else (
        REM ȊO @review
        echo ===[Error: Unknown parameter: %%a in create_report_html.bat] 1>&2
        @exit /B 1
    )
    
    REM eprojectcontent𐶐
    if !project_block_flg! equ 1 (

        REM CSV Filef[^̐
        if %%a equ 5 (
            REM test csv files̏ꍇ
            set csv_files_html=!csv_files_html!E!csv_file_name!
            set /a csv_file_count+=1
        )

        if !csv_file_block_flg! equ 0 (
            REM CSV Filef[^end_csvfilef[^
            if !csv_file_count! equ 0 (
                set "csv_files_html=CSVt@C͂܂"
            )
        )

        REM s𐶐
        if !row_block_flg! equ 1 (
            if %%a equ 12 (
                REM analysis result type Error ̏ꍇ
                set /a row_count+=1
                if !row_count! equ 1 (
                    set row=!row!!cmw_project_file_path!,
                    set row=!row!!csv_files_html!,
                ) else (
                    set row=!row!,,
                )
                set row=!row!!output_dir_path!,

            ) else if %%a equ 11 (
                REM analysis result type Warning ̏ꍇ
                set /a row_count+=1
                if !row_count! equ 1 (
                    set row=!row!!cmw_project_file_path!,
                    set row=!row!!csv_files_html!,
                ) else (
                    set row=!row!,,
               )
                set row=!row!!output_dir_path!\!sanitizerlog_file_name!,

            ) else if %%a equ 10 (
                REM analysis result type Success ̏ꍇ
                set /a row_count+=1
                if !row_count! equ 1 (
                    set row=!row!!cmw_project_file_path!,
                    set row=!row!!csv_files_html!,
                ) else (
                    set row=!row!,,
               )
                set row=!row!!output_dir_path!\!sanitizerlog_file_name!,
            )

            if %%a equ 0 (
            REM warnings̏ꍇ                
                (
                    set /a warning_row_count+=1
                    if !warning_row_count! equ 1 (
                        set warning_contents=Test Case:!test_count!,
                        set warning_contents=!warning_contents!!error_message!,!file_name!,!line!,!column!,
                    ) else (
                        set warning_contents=,,,,Test Case:!test_count!,!error_message!,!file_name!,!line!,!column!,
                    )
                )
            )
        )


        REM so
        if %%a equ 12 (
            REM Errors̏ꍇAo
            set row=!row!!log_meg!,
            set row=!row!!warning_contents!
            echo !row!
            set row=
            set warning_contents=
        ) else if %%a equ 11 (
            REM WarningLs̏ꍇ skip
        ) else if %%a equ 10 (
            REM WarningȂs̏ꍇAo
            set row=!row!!log_meg!,
            set row=!row!!warning_contents!
            echo !row!
            set row=
            set warning_contents=
        ) else if %%a equ 0 (
            REM warning̏ꍇ
            if !warning_row_count! equ 1 (
                REM warning1sڂ̏ꍇ
                set row=!row!!log_meg!,
                set row=!row!!warning_contents!
                echo !row!
                set row=
                set warning_contents=
            ) else (
                REM warning2sڍs̏ꍇ
                echo !warning_contents!
                set warning_contents=
            )
        )
    )

    REM vWFNgȈꍇ
    if !project_block_flg! equ 0 (
        set row_block_flg=2
        set csv_file_count=0
        set csv_files_html=
        set warning_row_count=0
    )
)
@exit /B 0