@echo off
@setlocal enabledelayedexpansion
@setlocal

@REM ----------------------------------------------------------------------------------------------
@REM search_sanitizer_ubsan_warning
@REM
@REM explanation:
@REM   1.Argument(sanitizerlog file path)2(targetKeyWord)܂ލsA܂ޏꍇ͍seo
@REM
@REM argument: 
@REM   %1 *.sanitizerlog file path
@REM   %2 targetKeyword
@REM   %3 [content] or [count](default:content)
@REM
@REM return: 
@REM   0: I
@REM   1: Error
@REM
@REM output: 
@REM   argument[content]:targetKeyWord܂ލso
@REM     test_count, targetKeyWord, Warning Message,handle function name, file name, row number, column number
@REM   argument[count]:*.Sanitizerlogt@Čo
@REM     test_count, targetKeyWord count, sanitizerlog file path
@REM ----------------------------------------------------------------------------------------------

if [%1]==[] goto :path_empty
if [%2]==[] goto :keyword_empty
if [%3]==[] goto :output_type_empty
set "sanitizerlog_file_path=%~1"
set "targetKeyWord=%2"
set target=%3
goto :main

:path_empty
echo ===[Error: Please input the arguments. *.sanitizerlog file path in search_sanitizer_ubsan_warning.bat] 1>&2
@exit /B 1

:keyword_empty
echo ===[Error: Please input the arguments. 1 arguments:sanitizer log path, 2 arguments:search keyword, 3 arguments:search keyword in search_sanitizer_ubsan_warning.bat] 1>&2
@exit /B 1

:output_type_empty
set "sanitizerlog_file_path=%~1"
set "targetKeyWord=%2"
set target=content
goto :main

:main
set "tokenkeyword_start=%%SX-I-XIPC"
set "tokenkeyword_end=returned"
set "tokenexit=%%winAMS-I-TEST"

REM 1̃t@CpX݂Ă邩mF
if not exist "%sanitizerlog_file_path%" (
    echo ===[Error code1: Please specify the arguments *.sanitizerlog file path in search_sanitizer_ubsan_warning.bat] 1>&2
    @exit /B 1
)

REM 1̃t@CpX.sanitizerlog܂܂mF
echo !sanitizerlog_file_path! | find ".sanitizerlog" > nul
if not %errorlevel%==0 (
	echo ===[Error code2: Please specify the arguments. *.sanitizerlog file path in search_sanitizer_ubsan_warning.bat] 1>&2
    @exit /B 1
)

REM 2contentɂȂĂ邩mF(2󗓂̏ꍇ)
if [%targetKeyWord%]==[content] (
    echo ===[Error code3: Please specify the arguments. 1 arguments:sanitizer log path, 2 arguments:search keyword, 3 arguments:content or count or redirect in search_sanitizer_ubsan_warning.bat] 1>&2
    @exit /B 1
)

REM 2countɂȂĂ邩mF(2󗓂̏ꍇ)
if [%targetKeyWord%]==[count] (
    echo ===[Error code4: Please specify the arguments. 1 arguments:sanitizer log path, 2 arguments:search keyword, 3 arguments:content or count or redirect in search_sanitizer_ubsan_warning.bat] 1>&2
    @exit /B 1
)

REM 2countɂȂĂ邩mF(2󗓂̏ꍇ)
if [%targetKeyWord%]==[redirect] (
    echo ===[Error code5: Please specify the arguments. 1 arguments:sanitizer log path, 2 arguments:search keyword, 3 arguments:content or count or redirect in search_sanitizer_ubsan_warning.bat] 1>&2
    @exit /B 1
)

if [%target%]==[content] goto :content
if [%target%]==[count] goto :count
if [%target%]==[redirect] goto :redirect
echo ===[Error: unknown target "%target%" in search_sanitizer_ubsan_warning.bat] 1>&2
@exit /B 1

:count
REM sanitizerlog filetargetKeyWord܂܂sԋp
set warning_count=0
for /f "usebackq delims=" %%x in (`type "!sanitizerlog_file_path!" ^| find /i /c !targetKeyWord!`) do (
    set /a warning_count=%%x
)
echo !warning_count!,!sanitizerlog_file_path!
@exit /B 0

:redirect
REM sanitizerlog filetargetKeyWord܂܂seԋp
for /f "usebackq tokens=1,2,3,4,5,6 delims=;:[]" %%a in (`type "!sanitizerlog_file_path!" ^| find /i !targetKeyWord!`) do (
    echo %%a,%%b,%%c,%%d,%%e,%%f
)
@exit /B 0

:content
set test_count=0
set token_flg=0
set function_name=
REM sanitizerlog filetargetKeyWord܂܂seԋp
for /f "usebackq tokens=1 delims=; skip=4" %%a in (`type "!sanitizerlog_file_path!"`) do (
    REM V~[VÕeXgJnSX-I-XIPCŔ

    echo %%a | find "!tokenkeyword_start!" > NUL
    if !errorlevel! equ 0 (
        REM V~[VÕeXgJn̏ꍇtoken_flg=ON
        set token_flg=1
        set /a test_count+=1
        REM for /f "usebackq tokens=1,2,3 delims=; """ %%b in (`echo %%a`) do (
        REM     set function_name=%%~nd
        REM )
    )

    REM V~[VÕeXgIreturnedŔ
    echo %%a | find "!tokenkeyword_end!" > NUL
    if !errorlevel! equ 0 (
        REM V~[VÕeXgȈꍇtoken_flg=OFF
        set token_flg=0
        set function_name=
    )

    REM V~[VÕeXgIreturnedŔ
    echo %%a | find "!tokenexit!" > NUL
    if !errorlevel! equ 0 (
        REM V~[VÕeXgȈꍇtoken_flg=OFF
        goto :end
    )

    REM echo ===========[token_flg:!token_flg! test_count:!test_count! a:%%a]  1>&2
    
    REM V~[VÕeXeXgJn̏ꍇ
    if !token_flg! equ 1 (
        REM L[[h܂܂ꍇ
        echo %%a | find !targetKeyWord! > NUL
        if !errorlevel! equ 0 (
            set line=%%a
            for /f "usebackq tokens=1,2,3,4,5,6 delims=:[]" %%a in (`echo [!line!]`) do (
                echo !test_count!,%%a,%%b,%%c,%%d,%%e,%%~f,!function_name!
            )
        )
    )
)

:end

@exit /B 0






